from . import AdGuardHomeDeviceEntity as AdGuardHomeDeviceEntity
from .const import DATA_ADGUARD_CLIENT as DATA_ADGUARD_CLIENT, DATA_ADGUARD_VERSION as DATA_ADGUARD_VERSION, DOMAIN as DOMAIN
from _typeshed import Incomplete
from adguardhome import AdGuardHome as AdGuardHome
from homeassistant.components.switch import SwitchEntity as SwitchEntity
from homeassistant.config_entries import ConfigEntry as ConfigEntry
from homeassistant.core import HomeAssistant as HomeAssistant
from homeassistant.exceptions import PlatformNotReady as PlatformNotReady
from homeassistant.helpers.entity_platform import AddEntitiesCallback as AddEntitiesCallback
from typing import Any

_LOGGER: Incomplete
SCAN_INTERVAL: Incomplete
PARALLEL_UPDATES: int

async def async_setup_entry(hass: HomeAssistant, entry: ConfigEntry, async_add_entities: AddEntitiesCallback) -> None: ...

class AdGuardHomeSwitch(AdGuardHomeDeviceEntity, SwitchEntity):
    _state: bool
    _key: Incomplete
    def __init__(self, adguard: AdGuardHome, entry: ConfigEntry, name: str, icon: str, key: str, enabled_default: bool = ...) -> None: ...
    @property
    def unique_id(self) -> str: ...
    @property
    def is_on(self) -> bool: ...
    _available: bool
    async def async_turn_off(self, **kwargs: Any) -> None: ...
    async def _adguard_turn_off(self) -> None: ...
    async def async_turn_on(self, **kwargs: Any) -> None: ...
    async def _adguard_turn_on(self) -> None: ...

class AdGuardHomeProtectionSwitch(AdGuardHomeSwitch):
    def __init__(self, adguard: AdGuardHome, entry: ConfigEntry) -> None: ...
    async def _adguard_turn_off(self) -> None: ...
    async def _adguard_turn_on(self) -> None: ...
    _state: Incomplete
    async def _adguard_update(self) -> None: ...

class AdGuardHomeParentalSwitch(AdGuardHomeSwitch):
    def __init__(self, adguard: AdGuardHome, entry: ConfigEntry) -> None: ...
    async def _adguard_turn_off(self) -> None: ...
    async def _adguard_turn_on(self) -> None: ...
    _state: Incomplete
    async def _adguard_update(self) -> None: ...

class AdGuardHomeSafeSearchSwitch(AdGuardHomeSwitch):
    def __init__(self, adguard: AdGuardHome, entry: ConfigEntry) -> None: ...
    async def _adguard_turn_off(self) -> None: ...
    async def _adguard_turn_on(self) -> None: ...
    _state: Incomplete
    async def _adguard_update(self) -> None: ...

class AdGuardHomeSafeBrowsingSwitch(AdGuardHomeSwitch):
    def __init__(self, adguard: AdGuardHome, entry: ConfigEntry) -> None: ...
    async def _adguard_turn_off(self) -> None: ...
    async def _adguard_turn_on(self) -> None: ...
    _state: Incomplete
    async def _adguard_update(self) -> None: ...

class AdGuardHomeFilteringSwitch(AdGuardHomeSwitch):
    def __init__(self, adguard: AdGuardHome, entry: ConfigEntry) -> None: ...
    async def _adguard_turn_off(self) -> None: ...
    async def _adguard_turn_on(self) -> None: ...
    _state: Incomplete
    async def _adguard_update(self) -> None: ...

class AdGuardHomeQueryLogSwitch(AdGuardHomeSwitch):
    def __init__(self, adguard: AdGuardHome, entry: ConfigEntry) -> None: ...
    async def _adguard_turn_off(self) -> None: ...
    async def _adguard_turn_on(self) -> None: ...
    _state: Incomplete
    async def _adguard_update(self) -> None: ...
